#! /bin/env python
#

class ParFile(object):
    """read a simple parameter file with key=val , one per line"""
    def __init__(self,file=None):
        self.pars={}
        if file == None: return
        self.load(file)
    def load(self,file):
        self.file = file
        f = open(file)
        lines = f.readlines()
        f.close()
        for line in lines:
            if line[0] == '#': continue
            line0 = line.strip()
            idx = line0.find('=')
            if idx<1: continue
            self.pars[line0[0:idx]] = line0[idx+1:]
    def argv(self,keyvals):
        """merge in key=val, usually from the command line """
        for kv in keyvals:
            idx = kv.find('=')
            if idx<1: continue
            self.pars[kv[0:idx]] = kv[idx+1:]
    def has(self,par):
        return self.pars.has_key(par)
    def get(self,par):
        return self.pars[par]
    def set(self,par,val):
        self.pars[par] = val
    def delete(self,par):
        junk = self.pars.pop(par)
    def csh(self):
        print "#-BEGIN for c-shell: created by ParFile::"
        for key in self.pars:
            print "set %s=%s" % (key,self.pars[key])
        print "#-END"
    def bash(self):
        print "#-BEGIN for bash-shell: created by ParFile::"
        for key in self.pars:
            print "export %s=%s" % (key,self.pars[key])
        print "#-END"
    def null(self):
        # nothing for now
        self.null = 1
    def save(self,file=None):
        if file==None:
            f = open(self.file,"w")
        else:
            f = open(file,"w")
        for key in self.pars:
            f.write("%s=%s\n" % (key,self.pars[key]))
        f.close()


if __name__ == '__main__':
    print "No __main__ yet, if ever...."

