import numpy as np
import matplotlib.pylab as plt
import carmatable as ct
import pacsplot as pp

def rmspathplot(col, rmspaths, project,file):
    rmsIn = ct.CarmaTable()
    rmsIn.open(file+"%03i.dat"%(col))
    rmslistCarma = rmsIn.getCol("CARMA RMS")
    rmslistCorrected = rmsIn.getCol("Corrected RMS")

    #print "LENGTH OF CARMA LIST:" + str(len(rmslistCarma))
    #print ""
    #print rmslistCarma
    #print "LENGTH OF CORRECTED LIST:" + str(len(rmslistCorrected))
    #print ""
    #print rmslistCorrected
    #print "LENGTH OF RMS PATH LIST:" + str(len(rmspaths))
    #print ""
    #print rmspaths
    
    #while len(rmspaths) < len(rmslistCarma):
    #    rmspaths.append(0)
    #    print "Appending 0 to rmspaths due to mismatched dimensions"
    
    if len(rmspaths) == len(rmslistCarma) == len(rmslistCorrected):
        plt.plot(rmspaths,rmslistCarma,'go')
        plt.plot(rmspaths,rmslistCorrected,'bo')
        plt.title("RMS Path versus RMS for %s"%(project))
        plt.xlabel('RMS Path')
        plt.ylabel('RMS of Baseline Phase')
        #Can cause crashes: For example, c0207.3B_230SerCla.2,  due to single interval
        if len(rmspaths)>1:
            ((linex,liney),(envelopex,envelopey),(slope,int,slopeerror,interror)) = pp.linregLists(rmspaths,rmslistCarma)
            plt.plot(linex,liney,'g-')
            plt.fill(envelopex,envelopey,'g',alpha=0.15)
            ((linex,liney),(envelopex,envelopey),(slope,int,slopeerror,interror)) = pp.linregLists(rmspaths,rmslistCorrected)
            plt.plot(linex,liney,'b-')
            plt.fill(envelopex,envelopey,'b',alpha=0.15)
        #if plt.axis()[0] < plt.axis()[2]:
        #    min = plt.axis()[0]
        #else:
        #    min = plt.axis()[2]
        #if plt.axis()[1] > plt.axis()[3]:
        #    max = plt.axis()[1]
        #else:
        #    max = plt.axis()[3]
        #plt.axis([min,max,min,max])
        plt.legend(('Std(CARMA)','Std(CARMA-SZA*3)'), 'best')
        #plt.legend(('Std(CARMA)','Std(CARMA-SZA*3)','Slope:%d'%(slope),'Slope Error:%d'%(slopeerror)), 'best')
def plots(project, file="finalTimes/finalCorrelation"):
    rmspIn = ct.CarmaTable()
    rmspIn.open("finalTimes/finalTimeHeader.txt")
    #rmspaths = rmspIn.getCol("Average RMS Path")
    rmspaths = rmspIn.getCol(6)

    count = 1

    plt.figure(num=1, figsize=(18.5,11), dpi=90)
    while (count <= 6):
        plt.subplot(2,3,count)
        rmspathplot(count, rmspaths, project, file)
        count = count + 1
    #plots first 6 plots
    plt.savefig("rmspath001.pdf", orientation='landscape')

    plt.figure(num=2, figsize=(18.5,11), dpi=90)
    while (count <= 12):
        plt.subplot(2,3,count-6)
        rmspathplot(count, rmspaths, project, file)
        count = count + 1
    #plots 7-12
    plt.savefig("rmspath002.pdf", orientation='landscape')

    plt.figure(num=3, figsize=(18.5,11), dpi=90)
    while (count <= 18):
        plt.subplot(2,3,count-12)
        rmspathplot(count, rmspaths, project, file)
        count = count + 1
    #plots 13-18
    plt.savefig("rmspath003.pdf", orientation='landscape')

    plt.figure(num=4, figsize=(18.5,11), dpi=90)
    while (count <= 24):
        plt.subplot(2,3,count-18)
        rmspathplot(count, rmspaths, project, file)
        count = count + 1
    #plots 19-24
    plt.savefig("rmspath004.pdf", orientation='landscape')

    plt.figure(num=5, figsize=(18.5,11), dpi=90)
    while (count <= 28):
        plt.subplot(2,3,count-24)
        rmspathplot(count, rmspaths, project, file)
        count = count + 1
    #plots 25-28
    plt.savefig("rmspath005.pdf", orientation='landscape')

    plt.close(1)
    plt.close(2)
    plt.close(3)
    plt.close(4)
    plt.close(5)
